package org.rayflood.mikuvat.io;

import java.io.File;

import javax.sound.midi.MetaMessage;
import javax.sound.midi.MidiMessage;
import javax.sound.midi.ShortMessage;
import javax.sound.midi.SysexMessage;

public abstract class MidiData extends ImmutableObject{
	private static final long serialVersionUID = 2907770619042609302L;

	public int compareTo(ImmutableObject obj){
		MidiData midiData = (MidiData)obj;
		return compare(getClass().getName(), midiData.getClass().getName());
	}

	public static MidiData newMidiData(MidiMessage mm){
		MidiData midiData = null;
		if(mm instanceof ShortMessage){
			midiData = new MidiShort(mm);
		}
		if(mm instanceof SysexMessage){
			midiData = new MidiSysex(mm);
		}
		if(mm instanceof MetaMessage){
			midiData = new MidiMeta(mm);
		}
		return midiData;
	}

	public abstract MidiMessage getMidiEvent() throws Exception;

	public abstract void setMidiEvent(MidiMessage mm);

	public MidiData clone(){
		return (MidiData)super.clone();
	}

	public static MidiData load(String file) throws Exception{
		return (MidiData)ImmutableObject.load(file);
	}

	public static MidiData load(File file) throws Exception{
		return (MidiData)ImmutableObject.load(file);
	}

	public void store(String file) throws Exception{
		super.store(file);
	}

	public void store(File file) throws Exception{
		super.store(file);
	}

	public static MidiData unzip(String file) throws Exception{
		return (MidiData)ImmutableObject.unzip(file);
	}

	public static MidiData unzip(File file) throws Exception{
		return (MidiData)ImmutableObject.unzip(file);
	}

	public void zip(String file) throws Exception{
		super.zip(file);
	}

	public void zip(File file) throws Exception{
		super.zip(file);
	}
}
